#!/usr/bin/python
# -*- coding: utf-8 -*-
# $Id: mdvvhdprovgui.py 273031 2011-07-04 10:29:04Z alissy $

# mdvvhdprovgui
# Written by Olivier Rosello on 10/2009
# olivier.rosello@mandriva.com
#

import sys
from ui_mdvvhdprovgui import *
from ui_about import *
from PyQt4.QtCore import QString

class MdvvhdprovAbout(QtGui.QWidget, Ui_About):
    def __init__(self):
        QtGui.QWidget.__init__(self)
        Ui_About.__init__(self)
        
        self.setupUi(self)
        self.connect(self.pushButton, QtCore.SIGNAL('clicked()'), self.closeAbout)
        
    def closeAbout(self):
        self.close()

class MdvvhdprovGui(QtGui.QMainWindow, Ui_mdvvhdprovgui):
    __authorgui__ = "Olivier Rosello"
    __author__ = "Alexandre Lissy"
    __version__ = "0.3"
    __commandline__ = "mdvvhdprov"
    filename = None
    arch = None
    fs = None
    mirror = None
    process = None
    deftext = QtGui.QApplication.translate("mdvvhdprovgui.py", '-- select --', None, QtGui.QApplication.UnicodeUTF8)
    # may be smarter later... :
    mirrors = [[deftext, ''],
               ['cooker', 'http://ftp.free.fr/mirrors/ftp.mandriva.com/MandrivaLinux/devel/cooker/'],
               ['current', 'http://ftp.free.fr/mirrors/ftp.mandriva.com/MandrivaLinux/official/current/'],
               ['2011.0', 'http://ftp.free.fr/mirrors/ftp.mandriva.com/MandrivaLinux/official/2011.0/'],
               ['2010.2', 'http://ftp.free.fr/mirrors/ftp.mandriva.com/MandrivaLinux/official/2010.2/'],
               ['2010.1', 'http://ftp.free.fr/mirrors/ftp.mandriva.com/MandrivaLinux/official/2010.1/'],
               ['2010.0', 'http://ftp.free.fr/mirrors/ftp.mandriva.com/MandrivaLinux/official/2010.0/'],
               ['2009.1', 'http://ftp.free.fr/mirrors/ftp.mandriva.com/MandrivaLinux/official/2009.1/'],
               ['2009.0', 'http://ftp.free.fr/mirrors/ftp.mandriva.com/MandrivaLinux/official/2009.0/'],
               ['2008.1', 'http://ftp.free.fr/mirrors/ftp.mandriva.com/MandrivaLinux/official/2008.1/'],
               ['2008.0', 'http://ftp.free.fr/mirrors/ftp.mandriva.com/MandrivaLinux/official/2008.0/'],
               ['2007.1', 'http://ftp.free.fr/mirrors/ftp.mandriva.com/MandrivaLinux/official/2007.1/'],
               ['2007.0', 'http://ftp.free.fr/mirrors/ftp.mandriva.com/MandrivaLinux/official/2007.0/'],
               ['2006.0', 'http://ftp.free.fr/mirrors/ftp.mandriva.com/MandrivaLinux/official/2006.0/'],
               ['9.2',    'http://ftp.free.fr/mirrors/ftp.mandriva.com/MandrivaLinux/official/9.2/'],
               ['9.1', 'http://ftp.free.fr/mirrors/ftp.mandriva.com/MandrivaLinux/official/9.1/']]

    def __init__(self):
        QtGui.QMainWindow.__init__(self)
        Ui_mdvvhdprovgui.__init__(self)

        self.setupUi(self)

        for l in self.mirrors:
            self.comboBoxMirror.addItem(l[0])

        self.connect(self.pushCancel, QtCore.SIGNAL('clicked()'), QtGui.qApp, QtCore.SLOT('quit()'))
        self.connect(self.pushGenerate, QtCore.SIGNAL("clicked()"), self.generate)
        self.connect(self.pushStop, QtCore.SIGNAL("clicked()"), self.processStop)
        self.connect(self.pushChoose, QtCore.SIGNAL("clicked()"), self.choix)
        self.connect(self.spinBoxVHDSize, QtCore.SIGNAL("valueChanged(int)"), self.spin)
        self.connect(self.comboBoxFs, QtCore.SIGNAL("currentIndexChanged(QString)"), self.fsCB)
        self.connect(self.lineEditFs, QtCore.SIGNAL("editingFinished()"), self.fsLE)
        self.connect(self.comboBoxArch, QtCore.SIGNAL("currentIndexChanged(QString)"), self.archCB)
        self.connect(self.lineEditArch, QtCore.SIGNAL("editingFinished()"), self.archLE)
        self.connect(self.comboBoxMirror, QtCore.SIGNAL("currentIndexChanged(QString)"), self.mirrorCB)
        self.connect(self.lineEditMirror, QtCore.SIGNAL("editingFinished()"), self.mirrorLE)
        self.connect(self.actionAbout, QtCore.SIGNAL("triggered()"), self.about)

    def about(self):
        self.ab = MdvvhdprovAbout()
        self.ab.show()

    def archLE(self):
        self.arch = self.lineEditArch.text()
        self.checkValid()

    def archCB(self):
        if (self.comboBoxArch.currentText() != self.deftext):
            self.arch = self.comboBoxArch.currentText()
            self.lineEditArch.setText(self.arch)
        else:
            self.arch = None
            self.lineEditArch.setText("")
        self.checkValid()

    def fsLE(self):
        self.fs = self.lineEditFs.text()
        self.checkValid()
        
    def fsCB(self):
        if (self.comboBoxFs.currentText() != self.deftext):
            self.fs = self.comboBoxFs.currentText()
            self.lineEditFs.setText(self.fs)
        else:
            self.fs = None
            self.lineEditFs.setText("")
        self.checkValid()

    def mirrorLE(self):
        mle = self.lineEditMirror.text()
        if (mle == '' or mle != self.mirrors[self.comboBoxMirror.currentIndex()][1]):
            self.comboBoxMirror.setCurrentIndex(0)
            self.lineEditMirror.setText(mle)
        self.mirror = mle
        self.checkValid()

    def mirrorCB(self):
        if (self.comboBoxMirror.currentText() != self.deftext):
            self.mirror = self.mirrors[self.comboBoxMirror.currentIndex()][1]
            self.lineEditMirror.setText(self.mirror)
        else:
            self.mirror = None
            self.lineEditMirror.setText("")
        self.checkValid()

    def checkValid(self):
        if self.filename and self.spinBoxVHDSize.value() and self.arch and self.fs and self.mirror:
            self.pushGenerate.setEnabled(True)
        else:
            self.pushGenerate.setEnabled(False)

    def spin(self):
        self.checkValid()

    def processStop(self):
        self.process.terminate()
        self.textBrowser.append("Execution terminated")
        self.pushStop.setEnabled(False)
        self.checkValid()

    def processState(self):
        self.pushStop.setEnabled(False)
        self.checkValid()

    def generate(self):
        self.process = QtCore.QProcess()
        self.connect(self.process, QtCore.SIGNAL("readyReadStandardOutput()"), self.readOutput)
        self.connect(self.process, QtCore.SIGNAL("readyReadStandardError()"), self.readError)
        self.connect(self.process, QtCore.SIGNAL("finished(int, QProcess::ExitStatus)"), self.processState)
        self.pushStop.setEnabled(True)
        self.pushGenerate.setEnabled(False)
        self.process.start(self.__commandline__,
                           [self.filename,
                            self.spinBoxVHDSize.text(),
                            self.fs,
                            self.arch,
                            self.mirror])
        self.textBrowser.setText("Starting...")
        self.textBrowser.append(self.__commandline__ + " " +
                                self.filename + " " +
                                self.spinBoxVHDSize.text() + " " +
                                self.fs + " " +
                                self.arch + " " +
                                self.mirror + "\n\n")
#        self.textBrowser.append("12345678901234567890123456789012345678901234567890123456789012345678901234567890")

    def readOutput(self):
        processOutput = QString.fromLocal8Bit(str(self.process.readAllStandardOutput()))
        self.textBrowser.append(QtCore.QString(processOutput))

    def readError(self):
        processOutput = QString.fromLocal8Bit(str(self.process.readAllStandardError()))
        self.textBrowser.append(QtCore.QString(processOutput))

    def choix(self):
        filename = QtGui.QFileDialog.getSaveFileName(self, QtGui.QApplication.translate("filechooser", 'Save Virtual Hard Drive', None, QtGui.QApplication.UnicodeUTF8), '.')
        if (filename):
            self.pushChoose.setText(filename)
            self.filename = filename
            self.checkValid()

if __name__ == "__main__":
    app = QtGui.QApplication(sys.argv)
    mdvvhdprovgui_locale_dir = "/usr/share/apps/mdvvhdprovgui/"
    locale = QtCore.QLocale.system().name()
    locale_module = 'mdvvhdprovgui_' + locale
    locale_file = mdvvhdprovgui_locale_dir + locale_module
    translator = QtCore.QTranslator(app)
    translator.load(locale_file)
    app.installTranslator(translator)
    window = MdvvhdprovGui()
    window.show()
    sys.exit(app.exec_())
